"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _getUrl = _interopRequireDefault(require("react-styleguidist/lib/client/utils/getUrl"));

var _ComponentsListRenderer = _interopRequireDefault(require("./ComponentsListRenderer"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function ComponentsList(_ref) {
  var items = _ref.items,
      _ref$useRouterLinks = _ref.useRouterLinks,
      useRouterLinks = _ref$useRouterLinks === void 0 ? false : _ref$useRouterLinks,
      useHashId = _ref.useHashId,
      hashPath = _ref.hashPath,
      isOpenCollapse = _ref.isOpenCollapse;
  var mappedItems = items.map(function (item) {
    return _objectSpread({}, item, {
      href: item.href ? item.href : (0, _getUrl.default)({
        name: item.name,
        slug: item.slug,
        anchor: !useRouterLinks,
        hashPath: useRouterLinks ? hashPath : false,
        id: useRouterLinks ? useHashId : false
      })
    });
  });
  return _react.default.createElement(_ComponentsListRenderer.default, {
    items: mappedItems,
    isOpenCollapse: isOpenCollapse
  });
}

ComponentsList.propTypes = {
  items: _propTypes.default.array.isRequired,
  hashPath: _propTypes.default.array,
  // eslint-disable-line react/require-default-props
  useRouterLinks: _propTypes.default.bool,
  // eslint-disable-line react/require-default-props
  useHashId: _propTypes.default.bool,
  // eslint-disable-line react/require-default-props
  // Added for our own documentation styling
  isOpenCollapse: _propTypes.default.bool.isRequired
};
var _default = ComponentsList;
exports.default = _default;
module.exports = exports.default;