"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _reactLifecyclesCompat = require("react-lifecycles-compat");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var _Preview = _interopRequireDefault(require("react-styleguidist/lib/client/rsg-components/Preview"));

var _Para = _interopRequireDefault(require("react-styleguidist/lib/client/rsg-components/Para"));

var _Slot = _interopRequireDefault(require("react-styleguidist/lib/client/rsg-components/Slot"));

var _consts = require("react-styleguidist/lib/client/consts");

var _PlaygroundRenderer = _interopRequireDefault(require("./PlaygroundRenderer"));

var _slots = require("../slots");

var Playground =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(Playground, _Component);

  function Playground(props, context) {
    var _this;

    (0, _classCallCheck2.default)(this, Playground);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Playground).call(this, props, context));
    var code = props.code,
        settings = props.settings,
        exampleMode = props.exampleMode;
    var config = context.config;
    var expandCode = exampleMode === _consts.ExampleModes.expand;
    var activeTab = settings.showcode !== undefined ? settings.showcode : expandCode;
    _this.state = {
      code: code,
      prevCode: code,
      activeTab: activeTab ? _slots.EXAMPLE_TAB_CODE_EDITOR : undefined
    };
    _this.handleTabChange = _this.handleTabChange.bind((0, _assertThisInitialized2.default)(_this));
    _this.handleChange = (0, _debounce.default)(_this.handleChange.bind((0, _assertThisInitialized2.default)(_this)), config.previewDelay);
    return _this;
  }

  (0, _createClass2.default)(Playground, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      // Clear pending changes
      this.handleChange.cancel();
    }
  }, {
    key: "handleChange",
    value: function handleChange(code) {
      this.setState({
        code: code
      });
    }
  }, {
    key: "handleTabChange",
    value: function handleTabChange(name) {
      this.setState(function (state) {
        return {
          activeTab: state.activeTab !== name ? name : undefined
        };
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          code = _this$state.code,
          activeTab = _this$state.activeTab;
      var _this$props = this.props,
          evalInContext = _this$props.evalInContext,
          index = _this$props.index,
          name = _this$props.name,
          settings = _this$props.settings,
          exampleMode = _this$props.exampleMode;
      var displayMode = this.context.displayMode;
      var isExampleHidden = exampleMode === _consts.ExampleModes.hide;
      var isEditorHidden = settings.noeditor || isExampleHidden;

      var preview = _react.default.createElement(_Preview.default, {
        code: code,
        evalInContext: evalInContext
      });

      return isEditorHidden ? _react.default.createElement(_Para.default, null, preview) : _react.default.createElement(_PlaygroundRenderer.default, {
        name: name,
        preview: preview,
        previewProps: settings.props || {},
        tabButtons: _react.default.createElement(_Slot.default, {
          name: "exampleTabButtons",
          active: activeTab,
          props: {
            onClick: this.handleTabChange
          }
        }),
        tabBody: _react.default.createElement(_Slot.default, {
          name: "exampleTabs",
          active: activeTab,
          onlyActive: true // evalInContext passed through to support custom slots that eval code
          ,
          props: {
            code: code,
            onChange: this.handleChange,
            evalInContext: evalInContext
          }
        }),
        toolbar: _react.default.createElement(_Slot.default, {
          name: "exampleToolbar",
          props: {
            name: name,
            isolated: displayMode === _consts.DisplayModes.example,
            example: index
          }
        })
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var code = nextProps.code;

      if (prevState.prevCode !== code) {
        return {
          prevCode: code,
          code: code
        };
      }

      return null;
    }
  }]);
  return Playground;
}(_react.Component);

(0, _defineProperty2.default)(Playground, "propTypes", {
  code: _propTypes.default.string.isRequired,
  evalInContext: _propTypes.default.func.isRequired,
  index: _propTypes.default.number.isRequired,
  name: _propTypes.default.string.isRequired,
  exampleMode: _propTypes.default.string.isRequired,
  settings: _propTypes.default.object // eslint-disable-line react/require-default-props

});
(0, _defineProperty2.default)(Playground, "contextTypes", {
  config: _propTypes.default.object.isRequired,
  displayMode: _propTypes.default.string
});

var _default = (0, _reactLifecyclesCompat.polyfill)(Playground);

exports.default = _default;
module.exports = exports.default;