"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Examples = _interopRequireDefault(require("react-styleguidist/lib/client/rsg-components/Examples"));

var _SectionHeading = _interopRequireDefault(require("react-styleguidist/lib/client/rsg-components/SectionHeading"));

var _JsDoc = _interopRequireDefault(require("react-styleguidist/lib/client/rsg-components/JsDoc"));

var _Markdown = _interopRequireDefault(require("react-styleguidist/lib/client/rsg-components/Markdown"));

var _Slot = _interopRequireDefault(require("react-styleguidist/lib/client/rsg-components/Slot"));

var _consts = require("react-styleguidist/lib/client/consts");

var _ReactComponentRenderer = _interopRequireDefault(require("./ReactComponentRenderer"));

var _slots = require("../slots");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var ExamplePlaceholder = process.env.STYLEGUIDIST_ENV !== 'production' ? require('rsg-components/ExamplePlaceholder').default : function () {
  return _react.default.createElement("div", null);
};

var ReactComponent =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(ReactComponent, _Component);

  function ReactComponent(props, context) {
    var _this;

    (0, _classCallCheck2.default)(this, ReactComponent);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(ReactComponent).call(this, props, context));
    var usageMode = props.usageMode;
    _this.handleTabChange = _this.handleTabChange.bind((0, _assertThisInitialized2.default)(_this));
    _this.state = {
      activeTab: usageMode === _consts.UsageModes.expand ? _slots.DOCS_TAB_USAGE : undefined
    };
    return _this;
  }

  (0, _createClass2.default)(ReactComponent, [{
    key: "handleTabChange",
    value: function handleTabChange(name) {
      this.setState(function (state) {
        return {
          activeTab: state.activeTab !== name ? name : undefined
        };
      });
    }
  }, {
    key: "render",
    value: function render() {
      var activeTab = this.state.activeTab;
      var _this$context = this.context,
          displayMode = _this$context.displayMode,
          pagePerSection = _this$context.config.pagePerSection;
      var _this$props = this.props,
          component = _this$props.component,
          depth = _this$props.depth,
          usageMode = _this$props.usageMode,
          exampleMode = _this$props.exampleMode;
      var name = component.name,
          visibleName = component.visibleName,
          slug = component.slug,
          filepath = component.filepath,
          pathLine = component.pathLine;
      var _component$props = component.props,
          description = _component$props.description,
          _component$props$exam = _component$props.examples,
          examples = _component$props$exam === void 0 ? [] : _component$props$exam,
          _component$props$tags = _component$props.tags,
          tags = _component$props$tags === void 0 ? {} : _component$props$tags;

      if (!name) {
        return null;
      }

      var showUsage = usageMode !== _consts.UsageModes.hide;
      return _react.default.createElement(_ReactComponentRenderer.default, {
        name: name,
        slug: slug,
        filepath: filepath,
        pathLine: pathLine,
        docs: _react.default.createElement(_JsDoc.default, tags),
        description: description && _react.default.createElement(_Markdown.default, {
          text: description
        }),
        heading: _react.default.createElement(_SectionHeading.default, {
          id: slug,
          pagePerSection: pagePerSection,
          deprecated: !!tags.deprecated,
          slotName: "componentToolbar",
          slotProps: _objectSpread({}, component, {
            isolated: displayMode !== _consts.DisplayModes.all
          }),
          depth: depth
        }, visibleName),
        examples: examples.length > 0 ? _react.default.createElement(_Examples.default, {
          examples: examples,
          name: name,
          exampleMode: exampleMode
        }) : _react.default.createElement(ExamplePlaceholder, {
          name: name
        }),
        tabButtons: showUsage && _react.default.createElement(_Slot.default, {
          name: "docsTabButtons",
          active: activeTab,
          props: _objectSpread({}, component, {
            onClick: this.handleTabChange
          })
        }),
        tabBody: _react.default.createElement(_Slot.default, {
          name: "docsTabs",
          active: activeTab,
          onlyActive: true,
          props: component
        })
      });
    }
  }]);
  return ReactComponent;
}(_react.Component);

exports.default = ReactComponent;
(0, _defineProperty2.default)(ReactComponent, "propTypes", {
  component: _propTypes.default.object.isRequired,
  depth: _propTypes.default.number.isRequired,
  exampleMode: _propTypes.default.string.isRequired,
  usageMode: _propTypes.default.string.isRequired
});
(0, _defineProperty2.default)(ReactComponent, "contextTypes", {
  config: _propTypes.default.object.isRequired,
  displayMode: _propTypes.default.string
});
module.exports = exports.default;