"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = SectionHeading;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Slot = _interopRequireDefault(require("react-styleguidist/lib/client/rsg-components/Slot"));

var _getUrl = _interopRequireDefault(require("react-styleguidist/lib/client/utils/getUrl"));

var _SectionHeadingRenderer = _interopRequireDefault(require("./SectionHeadingRenderer"));

function SectionHeading(_ref) {
  var slotName = _ref.slotName,
      slotProps = _ref.slotProps,
      children = _ref.children,
      id = _ref.id,
      pagePerSection = _ref.pagePerSection,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["slotName", "slotProps", "children", "id", "pagePerSection"]);
  var href = pagePerSection ? (0, _getUrl.default)({
    slug: id,
    id: rest.depth !== 1,
    takeHash: true
  }) : (0, _getUrl.default)({
    slug: id,
    anchor: true
  });
  return _react.default.createElement(_SectionHeadingRenderer.default, (0, _extends2.default)({
    toolbar: _react.default.createElement(_Slot.default, {
      name: slotName,
      props: slotProps
    }),
    id: id,
    href: href
  }, rest), children);
}

SectionHeading.propTypes = {
  children: _propTypes.default.node,
  // eslint-disable-line react/require-default-props
  id: _propTypes.default.string.isRequired,
  slotName: _propTypes.default.string.isRequired,
  slotProps: _propTypes.default.object.isRequired,
  depth: _propTypes.default.number.isRequired,
  deprecated: _propTypes.default.bool,
  // eslint-disable-line react/require-default-props
  pagePerSection: _propTypes.default.bool // eslint-disable-line react/require-default-props

};
module.exports = exports.default;