"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _TableOfContents = _interopRequireDefault(require("react-styleguidist/lib/client/rsg-components/TableOfContents"));

var _Sections = _interopRequireDefault(require("react-styleguidist/lib/client/rsg-components/Sections"));

var _Welcome = _interopRequireDefault(require("react-styleguidist/lib/client/rsg-components/Welcome"));

var _Error = _interopRequireDefault(require("react-styleguidist/lib/client/rsg-components/Error"));

var _NotFound = _interopRequireDefault(require("react-styleguidist/lib/client/rsg-components/NotFound"));

var _consts = require("react-styleguidist/lib/scripts/consts");

var _consts2 = require("react-styleguidist/lib/client/consts");

var _StyleGuideRenderer = _interopRequireDefault(require("./StyleGuideRenderer"));

/**
 * This function will return true, if the sidebar should be visible and false otherwise.
 *
 * These sorted conditions (highest precedence first) define the visibility
 * state of the sidebar.
 *
 * - Sidebar is hidden for isolated example views
 * - Sidebar is always visible when pagePerSection
 * - Sidebar is hidden when showSidebar is set to false
 * - Sidebar is visible when showSidebar is set to true for non-isolated views
 *
 * @param {boolean} displayMode
 * @param {boolean} showSidebar
 * @param {boolean} pagePerSection
 * @returns {boolean}
 */
function hasSidebar(displayMode, showSidebar) {
  return displayMode === _consts2.DisplayModes.notFound || showSidebar && displayMode === _consts2.DisplayModes.all;
}

var StyleGuide =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(StyleGuide, _Component);

  function StyleGuide() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, StyleGuide);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(StyleGuide)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "state", {
      error: false,
      info: null
    });
    return _this;
  }

  (0, _createClass2.default)(StyleGuide, [{
    key: "getChildContext",
    value: function getChildContext() {
      return {
        codeRevision: this.props.codeRevision,
        config: this.props.config,
        slots: this.props.slots,
        displayMode: this.props.displayMode
      };
    }
  }, {
    key: "componentDidCatch",
    value: function componentDidCatch(error, info) {
      this.setState({
        error: error,
        info: info
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          config = _this$props.config,
          sections = _this$props.sections,
          welcomeScreen = _this$props.welcomeScreen,
          patterns = _this$props.patterns,
          displayMode = _this$props.displayMode,
          allSections = _this$props.allSections,
          pagePerSection = _this$props.pagePerSection;

      if (this.state.error) {
        return _react.default.createElement(_Error.default, {
          error: this.state.error,
          info: this.state.info
        });
      }

      if (welcomeScreen) {
        return _react.default.createElement(_Welcome.default, {
          patterns: patterns
        });
      }

      return _react.default.createElement(_StyleGuideRenderer.default, {
        title: config.title,
        version: config.version,
        homepageUrl: _consts.HOMEPAGE,
        toc: _react.default.createElement(_TableOfContents.default, {
          sections: allSections,
          useRouterLinks: pagePerSection
        }),
        hasSidebar: hasSidebar(displayMode, config.showSidebar)
      }, sections.length ? _react.default.createElement(_Sections.default, {
        sections: sections,
        depth: 1
      }) : _react.default.createElement(_NotFound.default, null));
    }
  }]);
  return StyleGuide;
}(_react.Component);

exports.default = StyleGuide;
(0, _defineProperty2.default)(StyleGuide, "propTypes", {
  codeRevision: _propTypes.default.number.isRequired,
  config: _propTypes.default.object.isRequired,
  slots: _propTypes.default.object.isRequired,
  sections: _propTypes.default.array.isRequired,
  welcomeScreen: _propTypes.default.bool,
  // eslint-disable-line react/require-default-props
  patterns: _propTypes.default.array,
  // eslint-disable-line react/require-default-props
  displayMode: _propTypes.default.string,
  allSections: _propTypes.default.array.isRequired,
  pagePerSection: _propTypes.default.bool // eslint-disable-line react/require-default-props

});
(0, _defineProperty2.default)(StyleGuide, "childContextTypes", {
  codeRevision: _propTypes.default.number.isRequired,
  config: _propTypes.default.object.isRequired,
  slots: _propTypes.default.object.isRequired,
  displayMode: _propTypes.default.string
});
(0, _defineProperty2.default)(StyleGuide, "defaultProps", {
  displayMode: _consts2.DisplayModes.all
});
module.exports = exports.default;